SetUpListView proc uses edi esi
	LOCAL LVColumn:LV_COLUMN
	LOCAL LVItem:LV_ITEM
	LOCAL buffer[16]:byte
	LOCAL pth:POINT
	LOCAL ptv:POINT
	
	invoke RtlZeroMemory,addr LVColumn,sizeof LVColumn
	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov LVColumn.fmt,LVCFMT_CENTER
	mov LVColumn.lx,30
	mov LVColumn.cchTextMax,2
	
	invoke RtlZeroMemory,addr LVItem,sizeof LVItem
	mov LVItem.imask,LVIF_TEXT
	mov LVItem.cchTextMax,2
		
;	invoke GetDC,hListView
;	mov ecx,eax
;	invoke GetWindowOrgEx,ecx,addr pt
	
	mov pth.y,30
	sub pth.y,14
	mov pth.x,30
	add pth.x,2
	
	mov ptv.y,31
	mov ptv.x,30
	sub ptv.x,30

	mov ebx,0
	.while ebx <= 0fh
		push ebx
		invoke SendMessage,hListView,LVM_INSERTCOLUMN,0,addr LVColumn
		invoke SendMessage,hListView,LVM_INSERTITEM,0,addr LVItem

		invoke wsprintf,addr buffer,offset szFormat,ebx
		
		mov eax,ebx
		add eax,3000
		mov selectedCell.y,eax
		invoke CreateWindowEx,0,addr szStatic, NULL, \
				WS_CHILD or WS_VISIBLE or ES_CENTER or WS_BORDER, \
				pth.x,pth.y,31,15,hMain,eax,hInstance,0
		lea ecx,buffer
		push eax
		mov selectedCell.x,eax
		invoke SetWindowText,eax,ecx
		pop eax
		invoke InvalidateRect,eax,NULL,TRUE
		
		mov eax,ebx
		add eax,4000
		invoke CreateWindowEx,0,addr szStatic, NULL, \
				WS_CHILD or WS_VISIBLE or ES_CENTER or WS_BORDER or SS_CENTER, \
				ptv.x,ptv.y,30,15,hMain,eax,hInstance,0
		lea ecx,buffer
		push eax
		invoke SetWindowText,eax,ecx
		pop eax
		invoke InvalidateRect,eax,NULL,TRUE
		
		add pth.x,30
		add ptv.y,14
		pop ebx
		inc ebx
	.endw
	
	invoke SendMessage,hListView,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES,LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES
	
	ret
SetUpListView endp

FillListView proc
	LOCAL col:dword
	LOCAL row:dword
	LOCAL buffer[4]:byte
	
	mov col,0
	mov row,0
	
	.while row <= 0fh
		.while col <= 0fh
			invoke GetValue,row,col
			.if eax <= 20h || (eax >= 81h && eax <=90h) || (eax >=93h && eax <=9fh)
					.if eax==0 
						mov eax,256
					.endif
					lea ecx,buffer
					invoke LoadString,hInstance,eax,ecx,sizeof buffer
					mov al,byte ptr [buffer]
					.if al>=41h && al<=5Ah
						add byte ptr [buffer],20h
					.endif
					mov al,byte ptr [buffer + 1]
					.if al>=41h && al<=5Ah
						add byte ptr [buffer + 1],20h
					.endif
					mov al,byte ptr [buffer + 2]
					.if al>=41h && al<=5Ah
						add byte ptr [buffer + 2],20h
					.endif
					invoke setTextMatrix,row,col,addr buffer
			.elseif eax == 7fh
				mov byte ptr [buffer],"d"
				mov byte ptr [buffer + 1],"e"
				mov byte ptr [buffer + 2],"l"
				mov byte ptr [buffer + 3],0
				invoke setTextMatrix,row,col,addr buffer
				
			.else
				mov byte ptr [buffer],al
				mov byte ptr [buffer + 1],0
				invoke setTextMatrix,row,col,addr buffer
			.endif
			inc col
		.endw
		mov col,0
		inc row
	.endw
	
	
	ret

FillListView endp

getTextMatrix proc row:dword,col:dword,pText:dword
	LOCAL lvi:LV_ITEM
	
	invoke GetValue,row,col
	.if (eax <= 20h || eax == 7fh || eax >= 81h && eax <=90h || eax >=93h && eax <=9fh)
		mov byte ptr [pText],0
		xor eax,eax
	.elseif
		push row
		pop lvi.iItem
		push col
		pop lvi.iSubItem
		mov lvi.imask, LVIF_TEXT
		push pText
		pop lvi.pszText
		mov lvi.cchTextMax,4
		invoke SendMessage,hListView,LVM_GETITEM,0,addr lvi
		mov eax,TRUE
	.endif
	
    ret
    
getTextMatrix endp

setTextMatrix proc row:dword,col:dword,pText:dword
	LOCAL lvi:LV_ITEM
	
	push row
	pop lvi.iItem
	push col
	pop lvi.iSubItem
	mov lvi.imask, LVIF_TEXT
	push pText
	pop lvi.pszText
	mov lvi.cchTextMax,4
	invoke SendMessage,hListView,LVM_SETITEM,0,addr lvi

    ret
    
setTextMatrix endp

GetValue proc row:dword, col:dword
	
	mov eax,row
	mov ecx,16
	mul ecx
	add eax,col

	ret

GetValue endp

LVWinProc PROC hLV:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL hti:LVHITTESTINFO
	LOCAL row:dword
	LOCAL col:dword
	LOCAL buffer[128]:byte
	
	.if uMsg==WM_MOUSEMOVE
		mov eax,lParam
		mov hti.pt.x,eax
		and hti.pt.x,0ffffh
		mov hti.pt.y,eax
		shr hti.pt.y,16
		invoke SendMessage,hListView,LVM_HITTEST,0,addr hti
		mov eax,hti.iItem
		mov row,eax
		invoke SendMessage,hListView,LVM_SUBITEMHITTEST ,0,addr hti
		mov eax,hti.iSubItem
		mov col,eax
		
		invoke GetValue,row,col
		.if eax==0 
			mov eax,256
		.endif
		lea ecx,buffer
		invoke LoadString,hInstance,eax,ecx,sizeof buffer
		invoke SetDlgItemText,hMain,IDC_STC3,addr buffer
		
	.elseif uMsg==WM_LBUTTONDOWN
		;to avoid highlightning of selected row
		invoke CallWindowProc,OldLVWinProc,hLV,WM_LBUTTONDBLCLK,wParam,lParam
		ret
	.elseif uMsg==WM_RBUTTONDOWN
		xor eax,eax
		ret
	
	.endif
	
	invoke CallWindowProc,OldLVWinProc,hLV,uMsg,wParam,lParam
	ret

LVWinProc endp

